Subject: Re: [PATCH] checkout: indicate when a detached head is checked out for a branch

From: Michael J Gruber <[email-masked]>
Date: Mon, 21 Jul 2014 15:03:28 +0200

Junio C Hamano venit, vidit, dixit 19.07.2014 00:18:
> Dennis Kaarsemaker <[email-masked]> writes:
> 
>> My use case for this is checking out the same branch (or commit, so
>> already on a detached HEAD) in multiple different places to run
>> independent actions (e.g. make test with different compiler options, or
>> creating several different packages) and I would really appreciate it if
>> that would keep working.
> 
> I do not have any problem if multiple working trees have the same
> commit checked out on their own detached HEADs at all.  The "should
> error out" was solely for the case where the user asked not to detach
> but to obtain a state where a named branch is checked out.  In such
> a case, the command should not turn it into a detached HEAD, with or
> without a warning.

Exactly, all of that, plus:

* "git checkout --detach --to foo bar" could/should be a way to spell out
"git checkout --to foo bar^0".

* In the case of erroring out, "git checkout" could suggest one of the
above two commands.

Michael